now=`date`; echo "Starting at $now, pwd $PWD, this should be the Repeat_Library directory"

export DIR_GT=/home/mathog/src/genometools-1.5.9/bin
export DIR_CRL=/home/mathog/src/CRL_Scripts1.0
export DIR_RD=/home/mathog/src/RepeatModeler-open-1.0.10
export DIR_PE=/home/mathog/src/ProtExcluder1.2
export OKPROT=/home/mathog/etc/invertebrates_eleutherozoa_NOT_mobile_element_proteins.fasta
export OKTRNA=/home/mathog/etc/eukaryotic-tRNAs.fa
export DIR_TP=/home/mathog/etc
export FINAL_REPEATS=Lv_repeats.fasta #name for final file, holding repeats
export NCPU=48
if false #
then     #this block already completed, look for "fi #BLOCK" below
   echo "ERROR This should not be seen!"
fi #BLOCK

ln -s ../LvMSCB.fasta  seqfile
(cd ../MITE_Hunter_work; cat *_Step8_*.fa; cat *_Step8_singlet.fa) >MITE.lib

now=`date`; echo "Phase 1 $now was running MITE_Hunter, done manually previously"

now=`date`; echo "Phase 2.1.1 $now Collection of candidate elements with LTRs that are 99% or more in similarity using LTRharvest"
#The next two commands will enable the collection of sequences with following features:
#   Two terminal repeats which are >= 99% similar, ranging from 100 bp tp 6000 bp;
#   The two terminal repeats end with "TG...CA";
#   The size of entire element ranges from 1.5 kb to 25 kb;
#   The element must be flanked by a 5bp TSD (target site duplication).
#   The TSD is within 10 bp from the end of the element. 
$DIR_GT/gt suffixerator -db seqfile -indexname seqfileindex -tis -suf -lcp -des -ssp -dna
now=`date`; echo "Phase 1 $now after suffixerator"
$DIR_GT/gt ltrharvest -index seqfileindex -out seqfile.out99 -outinner seqfile.outinner99 \
   -gff3 seqfile.gff99 -minlenltr 100 -maxlenltr 6000 -mindistltr 1500 -maxdistltr 25000 \
   -mintsd 5 -maxtsd 5 -motif tgca -similar 99 -vic 10  > seqfile.result99


now=`date`; echo "Phase 2.1.2 $now Using LTRdigest to find elements with PPT (poly purine tract) or PBS (primer binding site)"
$DIR_GT/gt gff3 -sort seqfile.gff99 > seqfile.gff99.sort
$DIR_GT/gt ltrdigest -trnas $OKTRNA seqfile.gff99.sort seqfileindex > seqfile.gff99.dgt
perl  $DIR_CRL/CRL_Step1.pl --gff  seqfile.gff99.dgt

now=`date`; echo "Phase 2.1.3 $now Further filtering of the candidate elements"
perl $DIR_CRL/CRL_Step2.pl --step1 CRL_Step1_Passed_Elements.txt  \
   --repeatfile seqfile.out99 --resultfile seqfile.result99 \
   --sequencefile seqfile --removed_repeats   CRL_Step2_Passed_Elements.fasta
mkdir  fasta_files
mv  Repeat_*.fasta   fasta_files
mv  CRL_Step2_Passed_Elements.fasta  fasta_files
cd  fasta_files
perl $DIR_CRL/CRL_Step3.pl --directory  $PWD --step2 CRL_Step2_Passed_Elements.fasta \
 --pidentity 60 --seq_c 25 
mv  CRL_Step3_Passed_Elements.fasta  ..
cd  ..


now=`date`; echo "Phase 2.1.4. $now Identify elements with nested insertions"
perl $DIR_CRL/ltr_library.pl --resultfile seqfile.result99  --step3 CRL_Step3_Passed_Elements.fasta --sequencefile seqfile
cat lLTR_Only.lib  MITE.lib  > repeats_to_mask_LTR99.fasta
now=`date`; echo "Phase 2.1.4. $now before RepeatMaster"
RepeatMasker  -pa $NCPU -lib repeats_to_mask_LTR99.fasta   -nolow  -dir .  seqfile.outinner99
perl $DIR_CRL/cleanRM.pl  seqfile.outinner99.out  seqfile.outinner99.masked  >  seqfile.outinner99.unmasked
perl $DIR_CRL/rmshortinner.pl  seqfile.outinner99.unmasked  50 > seqfile.outinner99.clean

makeblastdb -in $DIR_TP/Tpases020812DNA  -dbtype prot
now=`date`; echo "Phase 2.1.4. $now before many_blast_plus_1cpu 1"
nice many_blast_plus_1cpu.sh blastx  seqfile.outinner99.clean seqfile.outinner99.clean_blastx.out.txt $NCPU \
  "-db $DIR_TP/Tpases020812DNA -evalue 1e-10 -num_descriptions 10"
perl  $DIR_CRL/outinner_blastx_parse.pl --blastx  seqfile.outinner99.clean_blastx.out.txt  --outinner  seqfile.outinner99
echo "Phase 2.1.5 Building examplars"
perl $DIR_CRL/CRL_Step4.pl --step3 CRL_Step3_Passed_Elements.fasta \
  --resultfile seqfile.result99 --innerfile passed_outinner_sequence.fasta \
  --sequencefile seqfile

makeblastdb -in lLTRs_Seq_For_BLAST.fasta  -dbtype nucl
now=`date`; echo "Phase 2.1.4. $now before many_blast_plus_1cpu 2"
nice many_blast_plus_1cpu.sh blastn lLTRs_Seq_For_BLAST.fasta lLTRs_Seq_For_BLAST.fasta.out $NCPU \
   "-db lLTRs_Seq_For_BLAST.fasta -evalue 1e-10 -num_descriptions 1000"

makeblastdb -in  Inner_Seq_For_BLAST.fasta  -dbtype nucl
now=`date`; echo "Phase 2.1.4. $now before many_blast_plus_1cpu 3"
nice many_blast_plus_1cpu.sh blastn Inner_Seq_For_BLAST.fasta Inner_Seq_For_BLAST.fasta.out $NCPU \
   "-db Inner_Seq_For_BLAST.fasta  -evalue 1e-10 -num_descriptions 1000"

perl $DIR_CRL/CRL_Step5.pl --LTR_blast lLTRs_Seq_For_BLAST.fasta.out \
   --inner_blast Inner_Seq_For_BLAST.fasta.out  \
   --step3 CRL_Step3_Passed_Elements.fasta --final LTR99.lib --pcoverage 90 --pidentity 80

now=`date`; echo "Phase 2.2. $now Collection of relatively old LTR retrotransposons"
#suffixerator step already performed, no need to repeat here
$DIR_GT/gt ltrharvest -index seqfileindex -out seqfile.out85 -outinner seqfile.outinner85 -gff3 seqfile.gff85 -minlenltr 100 \
-maxlenltr 6000 -mindistltr 1500 -maxdistltr 25000 -mintsd 5 -maxtsd 5 -vic 10  > seqfile.result85
now=`date`; echo "Phase 2.2. $now after ltrharvest"




now=`date`; echo "Phase 2.2.3 $now Further filtering of the candidate elements"
perl $DIR_CRL/CRL_Step2.pl --step1 CRL_Step1_Passed_Elements.txt  \
   --repeatfile seqfile.out85 --resultfile seqfile.result85 \
   --sequencefile seqfile --removed_repeats   CRL_Step2_Passed_Elements.fasta
mkdir  fasta85_files
mv  Repeat_*.fasta   fasta85_files
mv  CRL_Step2_Passed_Elements.fasta  fasta85_files
cd  fasta85_files
perl $DIR_CRL/CRL_Step3.pl --directory  $PWD --step2 CRL_Step2_Passed_Elements.fasta \
 --pidentity 60 --seq_c 25 
mv  CRL_Step3_Passed_Elements.fasta  ..
cd  ..


now=`date`; echo "Phase 2.2.4. $now Identify elements with nested insertions"
perl $DIR_CRL/ltr_library.pl --resultfile seqfile.result85  --step3 CRL_Step3_Passed_Elements.fasta --sequencefile seqfile
cat lLTR_Only.lib  MITE.lib  > repeats_to_mask_LTR85.fasta
now=`date`; echo "Phase 2.2.4. $now before RepeatMaster"
RepeatMasker  -pa $NCPU -lib repeats_to_mask_LTR85.fasta -nolow  -dir .  seqfile.outinner85
perl $DIR_CRL/cleanRM.pl  seqfile.outinner85.out  seqfile.outinner85.masked  >  seqfile.outinner85.unmasked
perl $DIR_CRL/rmshortinner.pl  seqfile.outinner85.unmasked  50 > seqfile.outinner85.clean

makeblastdb -in $DIR_TP/Tpases020812DNA  -dbtype prot
now=`date`; echo "Phase 2.2.4. $now before many_blast_plus_1cpu 1"
nice many_blast_plus_1cpu.sh blastx  seqfile.outinner85.clean seqfile.outinner85.clean_blastx.out.txt $NCPU \
  "-db $DIR_TP/Tpases020812DNA -evalue 1e-10 -num_descriptions 10"
perl  $DIR_CRL/outinner_blastx_parse.pl --blastx  seqfile.outinner85.clean_blastx.out.txt  --outinner  seqfile.outinner85
echo "Phase 2.2.5 Building examplars"
perl $DIR_CRL/CRL_Step4.pl --step3 CRL_Step3_Passed_Elements.fasta \
  --resultfile seqfile.result85 --innerfile passed_outinner_sequence.fasta \
  --sequencefile seqfile

makeblastdb -in lLTRs_Seq_For_BLAST.fasta  -dbtype nucl
now=`date`; echo "Phase 2.2.4. $now before many_blast_plus_1cpu 2"
nice many_blast_plus_1cpu.sh blastn lLTRs_Seq_For_BLAST.fasta lLTRs_Seq_For_BLAST.fasta.out $NCPU \
   "-db lLTRs_Seq_For_BLAST.fasta -evalue 1e-10 -num_descriptions 1000"

makeblastdb -in  Inner_Seq_For_BLAST.fasta  -dbtype nucl
now=`date`; echo "Phase 2.2.4. $now before many_blast_plus_1cpu 3"
nice many_blast_plus_1cpu.sh blastn Inner_Seq_For_BLAST.fasta Inner_Seq_For_BLAST.fasta.out $NCPU \
   "-db Inner_Seq_For_BLAST.fasta  -evalue 1e-10 -num_descriptions 1000"

perl $DIR_CRL/CRL_Step5.pl --LTR_blast lLTRs_Seq_For_BLAST.fasta.out \
   --inner_blast Inner_Seq_For_BLAST.fasta.out  \
   --step3 CRL_Step3_Passed_Elements.fasta --final LTR85.lib --pcoverage 90 --pidentity 80


now=`date`; echo "Phase 2.2 $now before RepeatMasker"

RepeatMasker  -pa $NCPU -lib LTR99.lib -dir . LTR85.lib
perl $DIR_CRL/remove_masked_sequence.pl  --masked_elements  LTR85.lib.masked  --outfile  FinalLTR85.lib
cat LTR99.lib FinalLTR85.lib > allLTR.lib

now=`date`; echo "Phase 3. $now Collecting repetitive sequences by RepeatModeler"
cat allLTR.lib MITE.lib > allMITE_LTR.lib
RepeatMasker  -pa $NCPU -lib allMITE_LTR.lib -dir . seqfile
perl $DIR_CRL/rmaskedpart.pl  seqfile.masked  50  >  umseqfile

#this form does not work for some reason
#$DIR_RD/BuildDatabase -name umseqfiledb -engine ncbi <umseqfile
cat >fasta_file.txt <<EOD
umseqfile
EOD
$DIR_RD/BuildDatabase -name umseqfiledb -engine ncbi -batch fasta_file.txt
nohup $DIR_RD/RepeatModeler -pa $NCPU -database umseqfiledb >& umseqfile.out 

ls -al | grep \ RM_
echo "if there is more than one RM_* subdirectory the wrong consensi.fa.classified file may be used"
echo "WARNING this section of commands.sh needs work"

cp RM_*/consensi.fa.classified .

perl $DIR_CRL/repeatmodeler_parse.pl --fastafile consensi.fa.classified \
   --unknowns repeatmodeler_unknowns.fasta  \
   --identities repeatmodeler_identities.fasta

now=`date`; echo "Phase 3. $now, before makeblastdb"
makeblastdb -in $DIR_TP/Tpases020812  -dbtype prot
nice many_blast_plus_1cpu.sh blastx repeatmodeler_unknowns.fasta modelerunknown_blast_results.txt $NCPU \
   "-db $DIR_TP/Tpases020812  -evalue 1e-10 -num_descriptions 10"

now=`date`; echo "Phase 3. $now, before transposon_blast_parse"
perl $DIR_CRL/transposon_blast_parse.pl --blastx modelerunknown_blast_results.txt --modelerunknown repeatmodeler_unknowns.fasta

mv  unknown_elements.txt  ModelerUnknown.lib
cat  identified_elements.txt  repeatmodeler_identities.fasta  > ModelerID.lib

now=`date`; echo "Phase 4. $now Exclusion of gene fragments"
#repeatmodeler in original blastx corresponding to below does NOT look right.  contacted kevin childs (his page, I think) to see
ln -s $OKPROT okprot
makeblastdb -in okprot  -dbtype prot
now=`date`; echo "Phase 4. $now before many_blast_plus_1cpu"
nice many_blast_plus_1cpu.sh blastx ModelerUnknown.lib ModelerUnknown.lib_blast_results.txt $NCPU \
 "-db okprot -evalue 1e-10 -num_descriptions 10"

now=`date`; echo "Phase 4. $now before ProtExcluder"
$DIR_PE/ProtExcluder.pl ModelerUnknown.lib_blast_results.txt  ModelerUnknown.lib
#makes file: ModelerUnknown.libnoProtFinal 

echo "Final Results in this directory are in two fasta files:"
echo "  ModelerID.lib   Repeats which are similar to KNOWN repeats"
echo "  ModelerUnknown.libnoProtFinal  Repeats which are NOT similar to KNOWN repeats"
cat ModelerID.lib ModelerUnknown.libnoProtFinal MITE.lib > $FINAL_REPEATS
echo "Concatenated these with the MITE results and saved in $FINAL_REPEATS"
now=`date`; echo "Phase X. $now ALL DONE."
